﻿################################################################
# CBPTest-v3.0 with DBSP v1 ('Disk Benchmark String Procesing')#
# Written by Matt Larsen - Professional Services - Carbon Black#
################################################################
# The script can be run only from the command line in PowerShell
# 
# Ensure diskspd.exe and diskspd.xsd are in the same directory as this script.
#
# Prompt user to enter disk letter
write-host "Select a disk to test: "
$num = 0
Get-Volume | select -ExpandProperty DriveLetter | foreach {
    $str = [string]$num + ') ' + $_ + ':\'
    write-host $str
    $num++
}

$disk = Read-Host -Prompt "Please enter the number of the drive to test"
$disk = $(Get-Volume | select -ExpandProperty DriveLetter)[$disk] + ":"
#

# Clean up old results files, if they exist
$result1 = ".\result1.txt"
$result2 = ".\result2.txt"
$result3 = ".\result3.txt"

If (Test-Path $result1){
		Copy-Item .\result1.txt .\result1.old
		Remove-Item .\result1.txt
}

If (Test-Path $result2) {
		Copy-Item .\result2.txt .\RndRead.old
		Remove-Item .\result2.txt
}

If (Test-Path $result3) {
		Copy-Item .\result3.txt .\result3.old
		Remove-Item .\result3.txt
}

# Run the tests outputting to three output files
#######################################################################################
# NOTE: CHANGING ANY VALUES PAST THIS POINT INVALIDATES THE TEST AND ANY CERTIFICATION#
# DO NOT change anything below this point.                                            #
#######################################################################################
  Write-Host "Running Tests - this will take 21 minutes and 30 seconds. Ctrl-C to abort."

# All this to get rid of that pesky post-string space - thank you PowerShell.
  $cmd1= ".\diskspd -W5 -c59G -d900 -D1000 -t1 -O1 -x -F1 -L -h -o1 -s40k -w100 -C2 $disk\CbTestFile.bin >>.\result1.txt"

  $cmd2= ".\diskspd -W5 -c30k -d300 -D1000 -x -r -F1 -L -o4 -b8k -r -r75 -w25 -z -C2 $disk\CbTestFile.bin >>.\result2.txt"

  $cmd3= ".\diskspd -W5 -c72k -d300 -D1000 -x -r -F1 -L -o16 -b8k -r -r25 -w75 -z -C2 $disk\CbTestFile.bin >>.\result3.txt"
  
  $cmd4= "del $disk\CbTestfile.bin"

#The actual execution
Invoke-Expression $cmd1
Invoke-Expression $cmd2
Invoke-Expression $cmd3
Invoke-Expression $cmd4

# Parsing code engine (please do not modify anything below! There be Dragons here :)
  $rf = "result1.txt, result2.txt, result3.txt"
  Write-Host ("Processing files " + $rf + " generated by the diskspd command...")
  $rf = $rf -replace ", ", "," -split ","
  $tl = "Sequential Writes:|Random Reads:|Random Writes:" -split "\|"
  $lf1 = "Write IO"
  $lf2 = "thread"
  $MBps = "MiB/s"
  For ($j=0; $j -lt 3 ; $j++) {
  $ar = get-content $rf[$j]
    For ($i=0; $i -lt $ar.count ; $i++) {
      if (($ar[$i].Length -gt $lf2.Length) -and ($ar[$i-1].Length -ge $lf1.Length )) {
        if (($ar[$i].Substring(0,6)) -eq "thread") {
          if (($ar[$i-1].Substring(0,8)) -eq "Write IO") {
            $ar2 = $ar[$i] -replace " ","" -split "\|"
            For ($k=0; $k -lt $ar2.count ; $k++) {
              if ($ar2[$k] -eq $MBps) {
                $ar3 = $ar[$i+2] -replace " ","" -split "\|"
                Write-Host ($tl[$j] + " " + $ar3[$k] + " " + $MBps)
                break
              }
            }
            break
          }
        }
      }
    }
  }
  Write-Host "Program terminated."